#import "KeyForwardingOutlineView.h"

@implementation KeyForwardingOutlineView
- (void)keyDown:(NSEvent *)event
{
	BOOL keyWasHandled = NO;

	if([[event charactersIgnoringModifiers] characterAtIndex:0] == ' ')
		keyWasHandled = [[self delegate] userDidPressSpaceInOutlineView:self];
	else if([[event charactersIgnoringModifiers] characterAtIndex:0] == NSRightArrowFunctionKey)
		keyWasHandled = [[self delegate] userDidPressRightInOutlineView:self];
	else if([[event charactersIgnoringModifiers] characterAtIndex:0] == NSLeftArrowFunctionKey)
		keyWasHandled = [[self delegate] userDidPressLeftInOutlineView:self];
	
	if(! keyWasHandled)
		[super keyDown:event];

}

- (NSArray*)selectedItems;
{
	NSIndexSet* selectedRows = [self selectedRowIndexes];
	NSMutableArray* items    = [NSMutableArray arrayWithCapacity:[selectedRows count]];
	int index                = [selectedRows firstIndex];

	while(index != NSNotFound)
	{
		[items addObject:[self itemAtRow:index]];
		index = [selectedRows indexGreaterThanIndex:index];
	}

	return items;
}
@end
